DIY 3.0 data-parallel out-of-core C++ library

- Main Page
- Modules
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Typedefs Groups Pages
Public Member Functions | Friends | List of all members
fmt::BasicStringRef< Char > Class Template Reference

`#include <diy/fmt/format.h>`

## Public Member Functions
| BasicStringRef (const Char *s, std::size_t size)
| BasicStringRef (const Char *s)
| BasicStringRef (const std::basic_string< Char > &s)
std::basic_string< Char > | to_string () const
const Char * | data () const
std::size_t | size () const
int | compare (BasicStringRef other) const

## Friends
bool | operator== (BasicStringRef lhs, BasicStringRef rhs)
bool | operator!= (BasicStringRef lhs, BasicStringRef rhs)
bool | operator< (BasicStringRef lhs, BasicStringRef rhs)
bool | operator<= (BasicStringRef lhs, BasicStringRef rhs)
bool | operator> (BasicStringRef lhs, BasicStringRef rhs)
bool | operator>= (BasicStringRef lhs, BasicStringRef rhs)

## Detailed Description

### template<typename Char>
class fmt::BasicStringRef< Char >

A string reference. It can be constructed from a C string or `std::string`.

You can use one of the following typedefs for common character types:

+---------—+----------------------—+ | Type | Definition | +============+=========================+ | StringRef | BasicStringRef<char> | +---------—+----------------------—+ | WStringRef | BasicStringRef<wchar_t> | +---------—+----------------------—+

This class is most useful as a parameter type to allow passing different types of strings to a function, for example::

template <typename... Args> std::string format(StringRef format_str, const Args & ... args);

format("{}", 42); format(std::string("{}"), 42);

## Constructor & Destructor Documentation

template<typename Char>

fmt::BasicStringRef< Char >::BasicStringRef | ( | const Char * | s,
|  | std::size_t | size
| ) |  |
| inline

Constructs a string reference object from a C string and a size.

template<typename Char>

fmt::BasicStringRef< Char >::BasicStringRef | ( | const Char * | s | ) |
| inline

Constructs a string reference object from a C string computing the size with `std::char_traits<Char>::length`.

template<typename Char>

fmt::BasicStringRef< Char >::BasicStringRef | ( | const std::basic_string< Char > & | s | ) |
| inline

Constructs a string reference from an `std::string` object.

## Member Function Documentation

template<typename Char>

const Char* fmt::BasicStringRef< Char >::data | ( |  | ) | const
| inline

Returns a pointer to the string data.

template<typename Char>

std::size_t fmt::BasicStringRef< Char >::size | ( |  | ) | const
| inline

Returns the string size.

template<typename Char>

std::basic_string<Char> fmt::BasicStringRef< Char >::to_string | ( |  | ) | const
| inline

Converts a string reference to an `std::string` object.

The documentation for this class was generated from the following file:

- include/diy/fmt/format.h